; original Z-Out boot
; + several patchs
; fix gfx bug level 5, weapons in 2 players mode, original ingamekey trainer
; fix Intro : correct centering of Advantec logo
; crack : skip test from decode in Intro code
 
	dc.b 'DOS',0
	dc.l 0
	dc.l 880

Boot:		
	move.w	#$180,$DFF096	; black out
	clr.w	$DFF180

	lea	ecs(pc),a5
	bsr	check_denise
	tst.l	d0		; 1 -> full ecs
	beq.s	.chkagnus
.chkagnus:
	* 0: standard pal | 1: standard ntsc | 2: ecs pal 
	* 3: ecs ntsc | 4: aga pal | 5: aga ntsc
	moveq.l	#0,d0		; check agnus
	move.b	$dff004,d0
	and.w	#$70,d0
	ror.b	#4,d0
	cmp.l	#2,d0		; ECS/AGA agnus ?
	blt.s	.ocs
	move.l	#1,(a5)		; set ECS flag
.ocs	
; -- original boot - getmem
	move.l	a1,-(sp)	; save trackdisk
	lea	Mem(pc),a5
	movea.l	4.w,a6
	move.l	#$20004,d1
	jsr	-$D8(a6)	; availmem(req)(d1)
	move.l	d0,4(a5)	; AvailMem
	move.l	#4,d1
	jsr	-$C6(a6)	; allocmem(size,req)(d0,d1)
	add.l	d0,4(a5)	; AvailMem+ptAllocMem
	clr.w	d0
	move.l	d0,(a5)		; AllocMem base
	movea.l	(sp)+,a1	; restore trackdisk

	move.w	#2,$1C(a1)
	move.l	#$50000,$28(a1)	; load crunched main program
	move.l	#44*512,$24(a1)	; len: 44*512
	move.l	#22*512,$2C(a1)	; offset: 22*512
	jsr	-$1C8(a6)

	move.w	#9,$1C(a1)	; stop motor
	clr.l	$24(a1)
	jsr	-$1C8(a6)

	move.w	#$7FFF,$DFF09A
	move.w	#$7FFF,$DFF096

	move.l	0(a5),d0	; ptAllocMem C00000
	move.l	4(a5),d1	; ptAvailMem+ptAllocMem	C7E800
; --	
	move.w	#$4e75,$5012a	; replace JMP $40000 by RTS
	jsr	$50024		; decrunch to 40000 and return here
;----------------------------------------------------------------------- FIXES and SET PATCH
; patch main prog @ 40000
	; trainer key j+k replaced by j+i (by whd team jotd/harry: pb with a2000/4000 keyboard)
	move.b	#$17,$40100+$1A9B	; replace keycode "K" by "I"

	; fix weapons in 2 players mode (by Angels/Defjam)
	move.b	#$14,$40100+$3E5A	; clr.w $12(a3) -> clr.w $14(a3)
	move.b	#$14,$40100+$3E60	; addq.w #1,$12(a3) -> addq.w #1,$14(a3)

	; gfx bug in level 5 (by harry/whdteam)
	move.b	#$20,$40100+$7C34	; copperlist wait $4000 -> $2000

	; install patch Intro
	movem.l	d7/a0-a1,-(sp)

	lea	$b8.w,a0
	move.l	a0,$40100+$5DA		; replace JSR $B000.L by JSR $B8.w

	lea	patchintro(pc),a1	; copy patch to $b8 (unused address)
	lea	$40100+$b8,a0
	moveq	#sizepi-1,d7
.copy	move.b	(a1)+,(a0)+
	dbf	d7,.copy

	movem.l	(sp)+,d7/a0-a1

	jmp	$40000		; start
;----------------------------------------------------------------- PATCH CRACK/HISCORE SAVE
patchintro:
	; correct centering of Advantec logo in ECS only (full ECS or ECS Agnus)
	lea	ecs(pc),a0
	tst.l	(a0)
	beq.s	.ocs

	move.l	#$23e94,$bd80	; $23e84 -> $23e94 -> but issue with hiscore panel (characters shifted)
	move.l	#$fffffffc,$c41a ;small alnum letters (see hiscore)
.ocs
	; crack it!
	; hiscore-track (01) acts also as protection
	; content loaded @ $d2f6-$d396
	; original game-resetscores @ $d396-$d436
	move.b	#$60,$f40a	; tst d7. beq -> bra $f434 : success check

	; read hiscore track : replace original sync word by standard sync
	move.w	#$4489,$f488	; normal sync word ($4521)
	move.w	#$4489,$f4d6+2	; orig. $4521
	move.w	#$4489,$f4dc+2	; orig. $4521

	; write hiscore track : replace sync word
	move.l	#$44894489,$f6ac+2	; sync word $45214521

	; start 
	jmp	$B000

ecs	dc.l	0
sizepi=*-patchintro

Mem:	ds.l	2
;--------------------------- ECS Denise/Agnus check by Hitchikr
* -------------------------- determine le type de denise *
* resultat dans d0
* 0: normal denise | 1: ecs denise | 2: aga denise
check_denise		
	moveq.l	#0,d0
	moveq.l	#0,d1
	move.w	$dff07c,d1
	and.w	#$ff,d1
	cmp.b	#$ff,d1
	beq.b	pas_nea_denise
	addq.l	#1,d0
	cmp.b	#$fc,d1
	beq.b	pas_nea_denise
	addq.l	#1,d0
	cmp.b	#$f8,d1
	beq.b	pas_nea_denise
	addq.l	#1,d0
pas_nea_denise	
	move.l	d0,(a5)
	rts

	dc.b 'postproduction : Dennis M. Ploeger    .   postproduction s'
	dc.b 'upervisor : Julian Eggebrecht     ',0
		
	dc.b	'== Cracked and Fixed by VrS! =='
	even
		END
